#include "power_supply.h"

//-------------------------------------------------------------
//------------------Adc Init Library---------------------------
void AdcInit(void){

	
	ADMUX = (1<<REFS1) | (1<<MUX1) | (1<<MUX3) | (1<<MUX4);
	
	ADCSRA = (1<<ADEN) | (1<<ADSC) | (1<<ADIE) | (1<<ADPS0) | (1<<ADPS1) | (1<<ADPS2) | (1<<ADATE); 
	ADCSRB = 0;
	DIDR0=(1<<AREFD);
	DIDR1= (1<<ADC9D) | (1<<ADC8D);

}

//-------------------------------------------------------------
//------------------PWM Start Library--------------------------
void PwmStart(unsigned int init_pwm_value){
	
	TCCR1A = (1<<COM1B1)|(1<<PWM1B);
	TCCR1D = (0<<WGM11)|(0<WGM10);
   	
	//Set PWM from target_pwm
   SetPwm(init_pwm_value);

	// Set PWM port pin to output.
	DDRB |= (1<<PB3);
	
	// Enable PLL, use full speed mode.
	PLLCSR = (0<<LSM) | (1<<PLLE);
	
	// Now wait for PLL to lock.
 	while((PLLCSR & (1<<PLOCK)) == 0){};

	// Use PLL as clock source.
	PLLCSR |= (1<<PCKE);
	
	// CLK PCK = 64MHz / 1 = 64MHz.
	TCCR1B |= (0<<CS13)|(0<<CS12)|(1<<CS11)|(0<<CS10);
}

//-------------------------------------------------------------
//------------------LCD Init Library---------------------------
void LcdInit(){
		
	_delay_ms(500);
    /* initialize display, cursor off */
   lcd_init(LCD_DISP_ON);
	lcd_clrscr();
}

//-------------------------------------------------------------
//------------------LCD Refresh--------------------------------

void LcdRefresh(void){
	char buffer[4],buffer1[4];
	
	//Disable global interrupts
	cli();	

	//convert interger into string 
  	itoa( Adc_value , buffer, 10);
	itoa( target_pwm , buffer1, 10);
	
	//Enable Global interrupts
	sei();	

	lcd_clrscr();

	lcd_gotoxy(0,0);
	lcd_puts("PWM=\n");
	lcd_gotoxy(4,0);
	lcd_puts(buffer1);
	lcd_gotoxy(0,1);
	lcd_puts("ADC=\n");
	lcd_gotoxy(4,1);
	lcd_puts(buffer);
}
